diff --git a/src/bin/psql/tab-complete.c b/src/bin/psql/tab-complete.c
index 47a1a19..bb66078 100644
--- a/src/bin/psql/tab-complete.c
+++ b/src/bin/psql/tab-complete.c
@@ -1010,6 +1010,7 @@ static const pgsql_thing_t words_after_create[] = {
 	{"DATABASE", Query_for_list_of_databases},
 	{"DEFAULT PRIVILEGES", NULL, NULL, NULL, THING_NO_CREATE | THING_NO_DROP},
 	{"DICTIONARY", Query_for_list_of_ts_dictionaries, NULL, NULL, THING_NO_SHOW},
+	{"DISK QUOTA", NULL, NULL, NULL},
 	{"DOMAIN", NULL, NULL, &Query_for_list_of_domains},
 	{"EVENT TRIGGER", NULL, NULL, NULL},
 	{"EXTENSION", Query_for_list_of_extensions},
diff --git a/src/include/catalog/indexing.h b/src/include/catalog/indexing.h
index 254fbef..e7065cc 100644
--- a/src/include/catalog/indexing.h
+++ b/src/include/catalog/indexing.h
@@ -360,4 +360,12 @@ DECLARE_UNIQUE_INDEX(pg_subscription_subname_index, 6115, on pg_subscription usi
 DECLARE_UNIQUE_INDEX(pg_subscription_rel_srrelid_srsubid_index, 6117, on pg_subscription_rel using btree(srrelid oid_ops, srsubid oid_ops));
 #define SubscriptionRelSrrelidSrsubidIndexId 6117
 
+DECLARE_UNIQUE_INDEX(pg_diskquota_oid_index, 6124, on pg_diskquota using btree(oid oid_ops));
+#define DiskQuotaOidIndexId 6124
+DECLARE_UNIQUE_INDEX(pg_diskquota_name_index, 6125, on pg_diskquota using btree(quotaname name_ops));
+#define DiskQuotaNameIndexId 6125
+
+DECLARE_UNIQUE_INDEX(pg_diskquota_target_oid_index, 6126, on pg_diskquota using btree(quotatargetoid oid_ops));
+#define DiskQuotaTargetOidIndexId 6126
+
 #endif							/* INDEXING_H */
diff --git a/src/include/catalog/pg_diskquota.h b/src/include/catalog/pg_diskquota.h
new file mode 100644
index 0000000..ff3f2df
--- /dev/null
+++ b/src/include/catalog/pg_diskquota.h
@@ -0,0 +1,60 @@
+/*-------------------------------------------------------------------------
+ *
+ * pg_diskquota.h
+ *	  definition of the "diskquota" system catalog (pg_diskquota)
+ *
+ *
+ * Portions Copyright (c) 1996-2018, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/catalog/pg_diskquota.h
+ *
+ * NOTES
+ *	  The Catalog.pm module reads this file and derives schema
+ *	  information.
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef PG_DISKQUOTA_H
+#define PG_DISKQUOTA_H
+
+#include "catalog/genbki.h"
+#include "catalog/pg_diskquota_d.h"
+
+/* ----------------
+ *	pg_diskquota definition.  cpp turns this into
+ *	typedef struct FormData_pg_diskquota
+ * ----------------
+ */
+
+typedef enum DiskQuotaType
+{
+	DISKQUOTA_TYPE_UNKNOWN = -1,
+
+	DISKQUOTA_TYPE_TABLE = 0,
+
+	DISKQUOTA_TYPE_SCHEMA = 1,
+
+	DISKQUOTA_TYPE_DATABASE = 3,
+
+	DISKQUOTA_TYPE_ROLE = 2,
+
+} DiskQuotaType;
+
+CATALOG(pg_diskquota,6122,DiskQuotaRelationId)
+{
+	NameData	quotaname;		/* diskquota name */
+	int16		quotatype;		/* diskquota type name */
+	Oid			quotatargetoid;	/* diskquota target db object oid*/
+	int32		quotalimit;		/* diskquota size limit in MB*/
+	int32		quotaredzone;	/* diskquota redzone in MB*/
+} FormData_pg_diskquota;
+
+/* ----------------
+ *	Form_pg_diskquota corresponds to a pointer to a tuple with
+ *	the format of pg_diskquota relation.
+ * ----------------
+ */
+typedef FormData_pg_diskquota *Form_pg_diskquota;
+
+#endif							/* PG_DISKQUOTA_H */
diff --git a/src/include/commands/diskquotacmd.h b/src/include/commands/diskquotacmd.h
new file mode 100644
index 0000000..26e62b5
--- /dev/null
+++ b/src/include/commands/diskquotacmd.h
@@ -0,0 +1,30 @@
+/*-------------------------------------------------------------------------
+ *
+ * diskquotacmd.h
+ *	  support for disk quota in different level.
+ *
+ *
+ * Portions Copyright (c) 1996-2018, PostgreSQL Global Development Group
+ *
+ * src/include/command/diskquotacmd.h
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#ifndef POSTGRES_DISKQUOTA_H
+#define POSTGRES_DISKQUOTA_H
+
+#include "postgres.h"
+#include "nodes/parsenodes.h"
+
+
+extern void CreateDiskQuota(CreateDiskQuotaStmt *stmt);
+extern void DropDiskQuota(DropDiskQuotaStmt *stmt);
+
+
+/* catalog access function */
+extern char *GetDiskQuotaName(Oid quotaid);
+extern Oid GetDiskQuotaOidByName(const char *name);
+
+
+#endif //POSTGRES_DISKQUOTA_H
diff --git a/src/include/nodes/nodes.h b/src/include/nodes/nodes.h
index cac6ff0..66a18f3 100644
--- a/src/include/nodes/nodes.h
+++ b/src/include/nodes/nodes.h
@@ -387,6 +387,8 @@ typedef enum NodeTag
 	T_AlterEnumStmt,
 	T_AlterTSDictionaryStmt,
 	T_AlterTSConfigurationStmt,
+	T_CreateDiskQuotaStmt,
+	T_DropDiskQuotaStmt,
 	T_CreateFdwStmt,
 	T_AlterFdwStmt,
 	T_CreateForeignServerStmt,
diff --git a/src/include/nodes/parsenodes.h b/src/include/nodes/parsenodes.h
index 62209a8..e19fc42 100644
--- a/src/include/nodes/parsenodes.h
+++ b/src/include/nodes/parsenodes.h
@@ -2207,6 +2207,38 @@ typedef struct AlterExtensionContentsStmt
 } AlterExtensionContentsStmt;
 
 /* ----------------------
+ *		Create/Alter/Drop Disk Quota Statements
+ * ----------------------
+ */
+
+
+typedef enum DiskQuotaDBObjectType
+{
+	DISK_QUOTA_TABLE = 0,		/* Quota in table level */
+	DISK_QUOTA_SCHEMA = 1,     /* Quota in schema level */
+	DISK_QUOTA_USER = 2	    /* Quota in user level */
+} DiskQuotaDBObjectType;
+
+typedef struct CreateDiskQuotaStmt
+{
+	NodeTag		type;
+	char	   *quotaname;		/* Disk Quota's name */
+	DiskQuotaDBObjectType       dbobjtype;			/* Type of Database object for disk quota */
+	RangeVar   *table;          /* The table relation if the DBObjectTyoe is DISK_QUOTA_TABLE*/
+	char       *objname;			/* Database object name */
+	List	   *options;			/* Disk quota options */
+} CreateDiskQuotaStmt;
+
+typedef struct DropDiskQuotaStmt
+{
+	NodeTag		type;
+	char	   *quotaname;		/* Disk Quota's name */
+	bool		missing_ok;
+} DropDiskQuotaStmt;
+
+
+
+/* ----------------------
  *		Create/Alter FOREIGN DATA WRAPPER Statements
  * ----------------------
  */
diff --git a/src/include/parser/kwlist.h b/src/include/parser/kwlist.h
index 23db401..be23eba 100644
--- a/src/include/parser/kwlist.h
+++ b/src/include/parser/kwlist.h
@@ -134,6 +134,7 @@ PG_KEYWORD("detach", DETACH, UNRESERVED_KEYWORD)
 PG_KEYWORD("dictionary", DICTIONARY, UNRESERVED_KEYWORD)
 PG_KEYWORD("disable", DISABLE_P, UNRESERVED_KEYWORD)
 PG_KEYWORD("discard", DISCARD, UNRESERVED_KEYWORD)
+PG_KEYWORD("disk", DISK, UNRESERVED_KEYWORD)
 PG_KEYWORD("distinct", DISTINCT, RESERVED_KEYWORD)
 PG_KEYWORD("do", DO, RESERVED_KEYWORD)
 PG_KEYWORD("document", DOCUMENT_P, UNRESERVED_KEYWORD)
@@ -317,6 +318,7 @@ PG_KEYWORD("procedure", PROCEDURE, UNRESERVED_KEYWORD)
 PG_KEYWORD("procedures", PROCEDURES, UNRESERVED_KEYWORD)
 PG_KEYWORD("program", PROGRAM, UNRESERVED_KEYWORD)
 PG_KEYWORD("publication", PUBLICATION, UNRESERVED_KEYWORD)
+PG_KEYWORD("quota", QUOTA, UNRESERVED_KEYWORD)
 PG_KEYWORD("quote", QUOTE, UNRESERVED_KEYWORD)
 PG_KEYWORD("range", RANGE, UNRESERVED_KEYWORD)
 PG_KEYWORD("read", READ, UNRESERVED_KEYWORD)
diff --git a/src/include/pgstat.h b/src/include/pgstat.h
index d59c24a..5caf0b9 100644
--- a/src/include/pgstat.h
+++ b/src/include/pgstat.h
@@ -703,6 +703,8 @@ typedef enum BackendType
 {
 	B_AUTOVAC_LAUNCHER,
 	B_AUTOVAC_WORKER,
+	B_DISKQUOTA_LAUNCHER,
+	B_DISKQUOTA_WORKER,
 	B_BACKEND,
 	B_BG_WORKER,
 	B_BG_WRITER,
@@ -756,6 +758,7 @@ typedef enum
 {
 	WAIT_EVENT_ARCHIVER_MAIN = PG_WAIT_ACTIVITY,
 	WAIT_EVENT_AUTOVACUUM_MAIN,
+	WAIT_EVENT_DISKQUOTA_MAIN,
 	WAIT_EVENT_BGWRITER_HIBERNATE,
 	WAIT_EVENT_BGWRITER_MAIN,
 	WAIT_EVENT_CHECKPOINTER_MAIN,
diff --git a/src/include/postmaster/diskquota.h b/src/include/postmaster/diskquota.h
new file mode 100644
index 0000000..7200c7f
--- /dev/null
+++ b/src/include/postmaster/diskquota.h
@@ -0,0 +1,72 @@
+/*-------------------------------------------------------------------------
+ *
+ * diskquota.h
+ *	  header file for integrated diskquota daemon
+ *
+ *
+ * Portions Copyright (c) 1996-2018, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/postmaster/diskquota.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef DISKQUOTA_H
+#define DISKQUOTA_H
+
+#include "nodes/parsenodes.h"
+#include "storage/block.h"
+
+/* GUC variables */
+extern char *guc_dq_database_list;
+extern bool diskquota_start_daemon;
+extern int	diskquota_max_workers;
+extern int	diskquota_work_mem;
+extern int	diskquota_naptime;
+extern int	diskquota_vac_thresh;
+extern double diskquota_vac_scale;
+extern int	diskquota_anl_thresh;
+extern double diskquota_anl_scale;
+extern int	diskquota_freeze_max_age;
+extern int	diskquota_multixact_freeze_max_age;
+extern int	diskquota_vac_cost_delay;
+extern int	diskquota_vac_cost_limit;
+
+/* diskquota launcher PID, only valid when worker is shutting down */
+extern int	DiskquotaLauncherPid;
+
+extern int	Log_diskquota_min_duration;
+
+/* Status inquiry functions */
+extern bool DiskQuotaingActive(void);
+extern bool IsDiskQuotaLauncherProcess(void);
+extern bool IsDiskQuotaWorkerProcess(void);
+
+#define IsAnyDiskQuotaProcess() \
+	(IsDiskQuotaLauncherProcess() || IsDiskQuotaWorkerProcess())
+
+/* Functions to start diskquota process, called from postmaster */
+extern void diskquota_init(void);
+extern int	StartDiskQuotaLauncher(void);
+extern int	StartDiskQuotaWorker(void);
+
+/* called from postmaster when a worker could not be forked */
+extern void DiskQuotaWorkerFailed(void);
+
+/* diskquota cost-delay balancer */
+extern void DiskQuotaUpdateDelay(void);
+
+#ifdef EXEC_BACKEND
+extern void DiskQuotaLauncherMain(int argc, char *argv[]) pg_attribute_noreturn();
+extern void DiskQuotaWorkerMain(int argc, char *argv[]) pg_attribute_noreturn();
+extern void DiskquotaWorkerIAm(void);
+extern void DiskquotaLauncherIAm(void);
+#endif
+
+
+/* shared memory stuff */
+extern Size DiskQuotaShmemSize(void);
+extern void DiskQuotaShmemInit(void);
+
+extern bool CheckTableQuota(RangeTblEntry *rte);
+#endif							/* DISKQUOTA_H */
diff --git a/src/include/storage/pmsignal.h b/src/include/storage/pmsignal.h
index 0747341..7749247 100644
--- a/src/include/storage/pmsignal.h
+++ b/src/include/storage/pmsignal.h
@@ -41,6 +41,8 @@ typedef enum
 	PMSIGNAL_BACKGROUND_WORKER_CHANGE,	/* background worker state change */
 	PMSIGNAL_START_WALRECEIVER, /* start a walreceiver */
 	PMSIGNAL_ADVANCE_STATE_MACHINE, /* advance postmaster's state machine */
+	PMSIGNAL_START_DISKQUOTA_LAUNCHER,    /* start an diskquota launcher */
+	PMSIGNAL_START_DISKQUOTA_WORKER,  /* start an diskquota worker */
 
 	NUM_PMSIGNALS				/* Must be last value of enum! */
 } PMSignalReason;
diff --git a/src/include/utils/dbsize.h b/src/include/utils/dbsize.h
new file mode 100644
index 0000000..e1286f7
--- /dev/null
+++ b/src/include/utils/dbsize.h
@@ -0,0 +1,18 @@
+/*-------------------------------------------------------------------------
+ *
+ * dbsize.h
+ *	  Definitions for dbsize functions.
+ *
+ *
+ * Portions Copyright (c) 1996-2018, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/utils/dbsize.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef DBSIZE_H
+#define DBSIZE_H
+
+int64 calculate_total_relation_size_by_oid(Oid relOid);
+#endif							/* DBSIZE_H */
diff --git a/src/include/utils/guc_tables.h b/src/include/utils/guc_tables.h
index 668d9ef..53b5aac 100644
--- a/src/include/utils/guc_tables.h
+++ b/src/include/utils/guc_tables.h
@@ -88,6 +88,7 @@ enum config_group
 	STATS_MONITORING,
 	STATS_COLLECTOR,
 	AUTOVACUUM,
+	DISKQUOTA,
 	CLIENT_CONN,
 	CLIENT_CONN_STATEMENT,
 	CLIENT_CONN_LOCALE,
diff --git a/src/include/utils/syscache.h b/src/include/utils/syscache.h
index 4f33358..9de408d 100644
--- a/src/include/utils/syscache.h
+++ b/src/include/utils/syscache.h
@@ -54,6 +54,9 @@ enum SysCacheIdentifier
 	CONVOID,
 	DATABASEOID,
 	DEFACLROLENSPOBJ,
+	DISKQUOTANAME,
+	DISKQUOTAOID,
+	DISKQUOTATARGETOID,
 	ENUMOID,
 	ENUMTYPOIDNAME,
 	EVENTTRIGGERNAME,
diff --git a/src/test/regress/parallel_schedule b/src/test/regress/parallel_schedule
index 16f979c..e411453 100644
--- a/src/test/regress/parallel_schedule
+++ b/src/test/regress/parallel_schedule
@@ -116,7 +116,7 @@ test: plancache limit plpgsql copy2 temp domain rangefuncs prepare without_oid c
 # ----------
 # Another group of parallel tests
 # ----------
-test: identity partition_join partition_prune reloptions hash_part indexing partition_aggregate
+test: identity partition_join partition_prune reloptions hash_part indexing partition_aggregate disk_quota
 
 # event triggers cannot run concurrently with any test that runs DDL
 test: event_trigger
diff --git a/src/test/regress/serial_schedule b/src/test/regress/serial_schedule
index 42632be..e444fa0 100644
--- a/src/test/regress/serial_schedule
+++ b/src/test/regress/serial_schedule
@@ -191,3 +191,4 @@ test: partition_aggregate
 test: event_trigger
 test: fast_default
 test: stats
+test: disk_quota
diff --git a/src/test/regress/sql/disk_quota.sql b/src/test/regress/sql/disk_quota.sql
new file mode 100644
index 0000000..06b7db2
--- /dev/null
+++ b/src/test/regress/sql/disk_quota.sql
@@ -0,0 +1,54 @@
+--
+-- Regression tests for disk quota
+--
+
+CREATE SCHEMA test_ns_disk_quota
+
+       CREATE TABLE quota_1 (
+              a int,
+              b int
+       );
+
+CREATE TABLE quota_2 (
+        a                       int2,
+        b                       float4
+);
+
+CREATE ROLE test_user_quota_1;
+
+CREATE DISK QUOTA abc ON TABLE quota_2 WITH ();
+
+CREATE DISK QUOTA abc ON TABLE quota_2 WITH (abc='100MB');
+
+CREATE DISK QUOTA abc ON TABLE quota_2 WITH (quota='100MB', abc='100MB');
+
+CREATE DISK QUOTA abc ON TABLE quota_2 WITH (quota='100MB', quota='200MB');
+
+CREATE DISK QUOTA abc ON TABLE quota_2 WITH (quota='100MB');
+
+CREATE DISK QUOTA abc ON TABLE quota_2 WITH (quota='100MB');
+
+CREATE DISK QUOTA abc_error ON TABLE quota_1 WITH (quota='100MB');
+
+CREATE DISK QUOTA abc_error ON SCHEMA quota_1 WITH (quota='100MB');
+
+CREATE DISK QUOTA abc_error ON USER quota_1 WITH (quota='100MB');
+
+CREATE DISK QUOTA abc ON SCHEMA test_ns_disk_quota WITH (quota='100MB');
+
+CREATE DISK QUOTA abc_1 ON SCHEMA test_ns_disk_quota WITH (quota='100MB');
+
+CREATE DISK QUOTA abc_2 ON TABLE test_ns_disk_quota.quota_1 WITH (quota='100MB');
+
+CREATE DISK QUOTA abc_3 ON USER test_user_quota_1 WITH (quota='100MB');
+
+
+DROP DISK QUOTA abc;
+DROP DISK QUOTA abc_1;
+DROP DISK QUOTA abc_2;
+DROP DISK QUOTA abc_3;
+DROP DISK QUOTA abc_no;
+
+DROP SCHEMA test_ns_disk_quota CASCADE;
+DROP TABLE quota_2;
+DROP ROLE test_user_quota_1;
-- 
1.8.3.1

